//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3D2D931101A6.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3D2D931101A6.cm

//## begin module%3D2D931101A6.cp preserve=no
//## end module%3D2D931101A6.cp

//## Module: MulTableComponent%3D2D931101A6; Package specification
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/MulTableComponent.h

#ifndef MULTABLECOMPONENT_H
#define MULTABLECOMPONENT_H 1

//## begin module%3D2D931101A6.additionalIncludes preserve=no
//## end module%3D2D931101A6.additionalIncludes

//## begin module%3D2D931101A6.includes preserve=yes
class UniqueEnergy;
//## end module%3D2D931101A6.includes

// MulComponent
#include <XSModel/Model/Component/MulComponent.h>

class TableComponent;

//## begin module%3D2D931101A6.declarations preserve=no
//## end module%3D2D931101A6.declarations

//## begin module%3D2D931101A6.additionalDeclarations preserve=yes
//## end module%3D2D931101A6.additionalDeclarations


//## begin MulTableComponent%36C456E12958.preface preserve=yes
//## end MulTableComponent%36C456E12958.preface

//## Class: MulTableComponent%36C456E12958
//## Category: XSModel::Model::Component%3666B89A8340
//## Subsystem: XSModel::Model::Component%367691A33718
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3D2DAC2B0372;ComponentBase { -> }

class MulTableComponent : public MulComponent  //## Inherits: <unnamed>%36C456F11640
{
  //## begin MulTableComponent%36C456E12958.initialDeclarations preserve=yes
  //## end MulTableComponent%36C456E12958.initialDeclarations

  public:
    //## Constructors (generated)
      MulTableComponent(const MulTableComponent &right);

    //## Constructors (specified)
      //## Operation: MulTableComponent%37EFA5421138;   C++
      MulTableComponent (CGroupBase* p);

    //## Destructor (generated)
      virtual ~MulTableComponent();


    //## Other Operations (specified)
      //## Operation: calculate%3767F03079B0;    C++
      void calculate (bool saveComponentFlux, bool frozen);

      //## Operation: read%374D98CBF3C5;     C++
      virtual int read ();

      //## Operation: clone%38E3B62655F0
      virtual MulTableComponent* clone (CGroupBase* p) const;

      //## Operation: clearArrays%3D7CF3770249
      virtual void clearArrays (const std::set<UniqueEnergy*>& currentEngs);

      //## Operation: initializeForFit%4593FF4300F6
      virtual void initializeForFit ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: tableFile%3767EFCB09C8
      const string& tableFile () const;
      void tableFile (const string& value);

    // Additional Public Declarations
      //## begin MulTableComponent%36C456E12958.public preserve=yes
      //## end MulTableComponent%36C456E12958.public

  protected:
    // Additional Protected Declarations
      //## begin MulTableComponent%36C456E12958.protected preserve=yes
      //## end MulTableComponent%36C456E12958.protected

  private:

    //## Other Operations (specified)
      //## Operation: swap%376139C9B0C8;    C++
      virtual void swap (Component& right);

      //## Operation: copy%3A953FA60366
      virtual void copy (const Component& right);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: tableType%3767EFF3C2C8
      const string tableType () const;
      void tableType (string value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Model::Component::<unnamed>%3D2D939D00F9
      //## Role: MulTableComponent::table%3D2D939D0339
      const TableComponent* table () const;
      void table (TableComponent* value);

    // Additional Private Declarations
      //## begin MulTableComponent%36C456E12958.private preserve=yes
      //## end MulTableComponent%36C456E12958.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin MulTableComponent::tableFile%3767EFCB09C8.attr preserve=no  public: string {U} ""
      string m_tableFile;
      //## end MulTableComponent::tableFile%3767EFCB09C8.attr

      //## begin MulTableComponent::tableType%3767EFF3C2C8.attr preserve=no  private: string {U} ""
      string m_tableType;
      //## end MulTableComponent::tableType%3767EFF3C2C8.attr

    // Data Members for Associations

      //## Association: XSModel::Model::Component::<unnamed>%3D2D939D00F9
      //## begin MulTableComponent::table%3D2D939D0339.role preserve=no  private: TableComponent { -> 1RFHgN}
      TableComponent* m_table;
      //## end MulTableComponent::table%3D2D939D0339.role

    // Additional Implementation Declarations
      //## begin MulTableComponent%36C456E12958.implementation preserve=yes
      bool m_expTable;
      //## end MulTableComponent%36C456E12958.implementation
};

//## begin MulTableComponent%36C456E12958.postscript preserve=yes
//## end MulTableComponent%36C456E12958.postscript

// Class MulTableComponent 

//## Get and Set Operations for Class Attributes (inline)

inline const string& MulTableComponent::tableFile () const
{
  //## begin MulTableComponent::tableFile%3767EFCB09C8.get preserve=no
  return m_tableFile;
  //## end MulTableComponent::tableFile%3767EFCB09C8.get
}

inline void MulTableComponent::tableFile (const string& value)
{
  //## begin MulTableComponent::tableFile%3767EFCB09C8.set preserve=no
  m_tableFile = value;
  //## end MulTableComponent::tableFile%3767EFCB09C8.set
}

inline const string MulTableComponent::tableType () const
{
  //## begin MulTableComponent::tableType%3767EFF3C2C8.get preserve=no
  return m_tableType;
  //## end MulTableComponent::tableType%3767EFF3C2C8.get
}

inline void MulTableComponent::tableType (string value)
{
  //## begin MulTableComponent::tableType%3767EFF3C2C8.set preserve=no
  m_tableType = value;
  //## end MulTableComponent::tableType%3767EFF3C2C8.set
}

//## Get and Set Operations for Associations (inline)

inline const TableComponent* MulTableComponent::table () const
{
  //## begin MulTableComponent::table%3D2D939D0339.get preserve=no
  return m_table;
  //## end MulTableComponent::table%3D2D939D0339.get
}

inline void MulTableComponent::table (TableComponent* value)
{
  //## begin MulTableComponent::table%3D2D939D0339.set preserve=no
  m_table = value;
  //## end MulTableComponent::table%3D2D939D0339.set
}

//## begin module%3D2D931101A6.epilog preserve=yes
//## end module%3D2D931101A6.epilog


#endif
